import { AfterViewInit, ChangeDetectorRef, ElementRef, EventEmitter, OnInit } from '@angular/core';
export declare class NgxNotificationMsgComponent implements OnInit, AfterViewInit {
    private readonly cd;
    private readonly element;
    private static readonly DELAY_ON_CLICK;
    status: NgxNotificationStatusMsg;
    direction: NgxNotificationDirection;
    displayProgressBar: boolean;
    displayIcon: boolean;
    header: string;
    color: string;
    messages: string[];
    delay: number;
    closeable: boolean;
    index: number;
    destroy: EventEmitter<any>;
    componentState: NgxNotificationMsgComponentState;
    componentStates: typeof NgxNotificationMsgComponentState;
    statusToColor: {
        [NgxNotificationStatusMsg.NONE]: string;
        [NgxNotificationStatusMsg.INFO]: string;
        [NgxNotificationStatusMsg.FAILURE]: string;
        [NgxNotificationStatusMsg.SUCCESS]: string;
    };
    msgs: string[];
    private readonly NONE;
    private closeTimeout;
    private destroyTimeout;
    private referencePointTimestamp;
    private mouseEnterTimestamp;
    constructor(cd: ChangeDetectorRef, element: ElementRef);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    isNotificationMsgOpened(): boolean;
    isProgressBarDisplayed(): boolean;
    isIconDisplayed(): boolean;
    getPosition(): INgxNotificationPosition;
    mouseEnter(): void;
    mouseLeave(): void;
    close(): void;
    private init;
    private initTheme;
    private getDefaultPosition;
    private getDynamicPosition;
    private autoSelfDestroy;
}
interface INgxNotificationPosition {
    top?: string;
    bottom?: string;
    left?: string;
    right?: string;
    transform: string;
}
export declare enum NgxNotificationMsgComponentState {
    CLOSE = "CLOSE",
    OPEN = "OPEN"
}
export declare enum NgxNotificationStatusMsg {
    SUCCESS = "SUCCESS",
    FAILURE = "FAILURE",
    INFO = "INFO",
    NONE = "NONE"
}
export declare enum NgxNotificationDirection {
    TOP = "TOP",
    TOP_RIGHT = "TOP_RIGHT",
    TOP_LEFT = "TOP_LEFT",
    BOTTOM = "BOTTOM",
    BOTTOM_RIGHT = "BOTTOM_RIGHT",
    BOTTOM_LEFT = "BOTTOM_LEFT"
}
export interface INgxNotificationMsgConfig {
    status?: NgxNotificationStatusMsg;
    direction?: NgxNotificationDirection;
    header?: string;
    messages: string[];
    color?: string;
    delay?: number;
    displayIcon?: boolean;
    displayProgressBar?: boolean;
    closeable?: boolean;
}
export {};
